/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: prc_support.S 2201 2011-07-26 12:29:03Z ertl-honda $
 */

/*
 *  ץå¸⥸塼 ֥ARM-Mѡ
 */

#define TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */
#define CAST(type, val)	(val)		/* 㥹ȤԤޥ */

#include "kernel_impl.h"
#include "arm_m.h"
#include "offset.h"


/*
 *  ǥѥå
 */
	.text
	.syntax unified
	.code 16
	.global dispatch
	.type dispatch, function
dispatch:
	/*
	 *
	 *  Υ롼ϡƥȡCPUå֡ǥѥåľ
	 *  ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ롥
	 */
	stmfd sp!,{r4-r11,lr}         /* 쥸¸ */
	ldr   r0, =p_runtsk           /* p_runtskɤ߹ */
	ldr   r1, [r0]
	str   sp, [r1,#TCB_sp]        /* å¸ */
	ldr   lr, =dispatch_r         /* ¹ԺƳϤ¸ */
	str   lr, [r1,#TCB_pc]        
	b     dispatcher

	.text
	.syntax unified
	.code 16
	.type dispatch_r, function
dispatch_r:
	ldmfd sp!,{r4 - r11,lr}       /* 쥸 */
	/*
	 * 㳰롼εư
	 * dispatcherƤӽФ뤿ᡤTCBΥɥ쥹r1äƤ
	 */
	ldrb  r0,[r1,#TCB_enatex]
	tst   r0,#TCB_enatex_mask
	beq   dispatch_r_1            /* enatex  false ʤ꥿ */
	ldr   r0,[r1,#TCB_texptn]     /* texptn 0Ǥʤ         */
	tst   r0,r0                 
	bne   call_texrtn             /* 㳰롼θƤӽФ */
dispatch_r_1:                     /* ؤcall_textn */
	mov   pc,lr


/*
 *  CPU㳰ȥ
 *
 *  ߥȥȽƤƱμबۤʤ뤿ᡤ
 *  ʬƤ롥
 */
	.align 2
	.syntax unified
	.code 16
	.global exc_entry
	.type exc_entry, function
exc_entry:
	/*
	 *  㳰/ߤȯȡȯ˥ƥ֤ʥå˥
	 *  å쥸¸롥
	 *  Ƥ˲äơCPU㳰ϥɥؤξȤơbasepri ͤȡ
	 *  EXC_RETURNξä¸롥basepriͤϡCPU㳰
	 *  ꥿˳ͥ٥ޥͤ򸵤᤹ˤѤ롥
	 *
	 *   -----------
	 *  | EXC_RETURN|  
	 *   -----------
	 *  |  basepri  |  
	 *   -----------
	 *  |    R0     |  
	 *   -----------
	 *  |    R1     |
	 *   -----------
	 *  |    R2     |
	 *   -----------
	 *  |    R3     |
	 *   -----------
	 *  |    R12    |
	 *   -----------
	 *  |    LR     |
	 *   -----------
	 *  |    PC     |
	 *   -----------
	 *  |   xPSR    |
	 *   -----------
	 *
	 */

	/*
	 *  ȯγͥ٥ޥ򥹥å¸뤿
	 */
	mrs   r2, basepri             /* baepriͤ */

	/*
	 * ¿ųߤå
	 * EXC_RETURNʳ߻LRꤵ͡ˤåơ㳰ȯ
	 * ƥ֤ʥåꤹ뤳Ȥ¿ųߤȽꤹ롥
	 */
	tst   lr, #EXC_RETURN_PSP    /* ߸MSPʤ¿ų */
	beq   exc_entry_1            /* ¿ųߤʤexc_entry_1 */
	mrs   r0, psp                /* ܤγߤξPSP */
	stmfd r0!,{r2}               /* ȯγͥ٥ޥѤ */
	stmfd r0!,{lr}               /* EXC_RETURN Ѥ             */
	msr   psp, r0                /* CPU㳰ϥɥؤΰȤʤ */
	push  {lr}                   /* MSPˤEXC_RETURN Ѥ    */ 
	b     exc_entry_2
exc_entry_1:                     /* ¿ųߤξ */
	push  {r2}                   /* ȯγͥ٥ޥѤ */
	push  {lr}                   /* EXC_RETURN Ѥ             */ 
	mov   r0, sp                 /* CPU㳰ϥɥؤΰȤʤ */

	/*
	 *  ̽
	 */
exc_entry_2:                     
	mrs   r3, ipsr               /* ϥɥ饢ɥ쥹 */
	ldr   r1, =_kernel_exc_tbl
	ldr   r2, [r1, r3, lsl #2]

#ifdef LOG_EXC_ENTER
	push  {r0,r2,r3}
	mov   r0, r3                 /* 㳰ֹѥ᡼  */
	bl    log_exc_enter          /* log_exc_enterƤӽФ */
	pop   {r0,r2,r3}
	push  {r3}                   /* 㳰ֹ򥹥å    */
#endif /* LOG_EXC_ENTER */

	/*
	 *  CPU㳰ϥɥθƤӽФ
	 */
	blx   r2

#ifdef LOG_EXC_ENTER
	pop   {r0}                   /* 㳰ֹ        */
	bl    log_exc_leave          /* log_exc_leaveƤӽФ */
#endif /* LOG_EXC_ENTER */

	b     ret_exc


/*
 *  ߥȥ
 */
	.align 2
	.syntax unified
	.code 16
	.global int_entry
	.type int_entry, function
int_entry:
	/*
	 *  ȯγͥ٥ޥ򥹥å¸뤿
	 */
	mrs   r2, basepri             /* baepriͤ */

	/*
	 * ¿ųߤå
	 * EXC_RETURNʳ߻LRꤵ͡ˤåơ㳰ȯ
	 * ƥ֤ʥåꤹ뤳Ȥ¿ųߤȽꤹ롥
	 */
	tst   lr, #EXC_RETURN_PSP    /* ߸MSPʤ¿ų */
	beq   int_entry_1            /* ¿ųߤʤint_entry_1    */
	mrs   r0, psp                /* ܤγߤξPSP */
	stmfd r0!,{r2}               /* ȯγͥ٥ޥѤ */
	stmfd r0!,{lr}               /* EXC_RETURN Ѥ             */
	msr   psp, r0                /* CPU㳰ϥɥؤΰȤʤ */
	push  {lr}                   /* MSPˤEXC_RETURN Ѥ    */ 
	b     int_entry_2
int_entry_1:                     /* ¿ųߤξ */
	push  {r2}                   /* ȯγͥ٥ޥѤ */
	push  {lr}                   /* EXC_RETURN Ѥ             */ 
	mov   r0, sp                 /* ̤γߤȯξȤ */

	/*
	 *  ̽
	 */
int_entry_2:                     
	mrs   r3, ipsr               /* ϥɥ饢ɥ쥹 */
	ldr   r1, =_kernel_exc_tbl
	ldr   r2, [r1, r3, lsl #2]

#ifdef LOG_INH_ENTER
	push  {r0,r2,r3}
	mov   r0, r3                 /* 㳰ֹѥ᡼  */
	bl    log_inh_enter          /* log_exc_enterƤӽФ */
	pop   {r0,r2,r3}
	push  {r3}                   /* 㳰ֹ򥹥å    */
#endif /* LOG_EXC_ENTER */

	/*
	 *  ߥϥɥθƤӽФ
	 */
	blx   r2

#ifdef LOG_INH_LEAVE
	pop   {r0}                   /* 㳰ֹ        */
	bl    log_exc_leave          /* log_exc_leaveƤӽФ */
#endif /* LOG_INH_LEAVE */



/*
 *  /㳰и
 *
 *  ret_exc/ret_intϡCPU㳰/ߥϥɥ餫äľ˼¹Ԥ
 *  롼Ǥ롥
 */
ret_exc:
ret_int:
	/*
	 *  ߥå֤Ȥ롥λǤϡCPUå֤ˤϤʤʤ
	 * baseprilock_flagsaved_iipmϹʤˡ
	 *
	 *  ߥå֤ȤΤϡΥƥȤΥåȡ
	 *  褬󥿥ƥȤǤäΥ꥿򥢥ȥߥå
	 *  ˹ԤǤ롥bsepriCPUåͤˤ뤳ȤǤ⥢ȥߥ
	 *  ʥåϲǽǤ뤬ߤ꥿󤷤Ƥ⡤
	 *  basepri ƤϸʤᡤѤ뤳ȤǤʤ 
	 *  FAULTMASKϡߤΥ꥿ˤäơ'0'˥
	 *  롥
	 */
	cpsid f                        

	/*
	 *  ΥƥȤȽ
	 * 
	 *  ߥϥɥ¹ԤLR˥åȤEXC_RETURNåơ
	 *  MSPȤƤС褬󥿥ƥȤȽꤹ롥
	 */
	pop   {r3}                     /* lr򥹥å         */
	tst   r3, #EXC_RETURN_PSP      /* 褬PSPʤ ret_int_1  */
	bne   ret_int_1
	pop   {r1}                     /* γͥ٥ޥ(basepri)r1 */
	b     ret_int_2                /* ͤMSP */

	/*
	 *  ܤγߤνи
	 */
ret_int_1:
	/*
	 *  reqflgå
	 * 
	 *  ͥγߤ϶ػߤ֤Ǽ¹Ԥɬפ뤿ᡤ
	 *  FAULTMASK'1'ˤ֤Ǽ¹Ԥ롥
	 *  reqflgå˳ߤػߤΤϡreqflgå
	 *  ľ˳ߥϥɥ餬ư졤ǥǥѥå׵
	 *  줿ˡ˥ǥѥåʤȤ꤬뤿
	 *  Ǥ롥
	 */
	ldr   r0, =reqflg             /* reqflgfalseʤ餽Τޤ */
	ldr   r1, [r0]
	cbnz  r1, ret_int_3           /* trueʤret_int_3           */
	mrs   r2, psp                 /* γͥ٥ޥ(basepri) */
	ldmfd r2!, {r0,r1}            /* ͤPSP(r1) */
	msr   psp, r2                 /* EXEC_RETURNɤ߼Τ */

ret_int_2:
	/*
	 *  ˤϳߥå֡FAULTMASKåȡˤ줿֤롥
	 *  Thread⡼ɤΥ꥿ˤ꼫ưŪ˳ߥå֤ˤʤ롥
	 *  ͥ٥ޥϳ˾֤᤹
	 */ 
	msr   basepri, r1             /* ͥ٥ޥ˾֤ */
	bx    r3                      /* ꥿ */


ret_int_3:
	/*
	 *  Ǥϡ褬ǤꡤPSP˥å쥸ȳ
	 *  ͥ٥ޥ(basepri)¸줿֤ˤʤäƤ롥ޤ
	 *  ץåϡHandler⡼ɡߥå֤ȤʤäƤ롥
	 *  ޤr0ˤϡreqflgΥɥ쥹r3ˤϳ߼ջlrͤ
	 *  Ƥ롥
	 */
	/*
	 *  㳰ϥɥǥѥå򤹤ݤThread⡼ɤܤ
	 *  ߡΥåե졼ơbx̿Handler⡼ɤ
	 *  󤹤롥ޤٱǥѥå⡤Ƥӳ
	 *  ݤˤϡsvc̿ǡsvc_handlerƤӽФ
	 *  åե졼ϡConfigureation and Control Register(CCR)
	 *  STKALIGN'1'ξϡ8byte˥饤󤵤롥
	 *   : DDI0403B_arm_architecture_v7m_reference_manual(P.220)
	 *  ΤᡤλΥåϳߤ㳰ȯ˺줿
	 *  åե졼फ顤8byteΥˤƤȡsvc_handler
	 *  ǥåե졼Υ饤Ȥ̵ͭγǧάǤ롥
	 *  ƥ൯ưϡưŪCCRSTKALIGNѹΤ
	 *  ػߤȤ롥
	 *  λɸΥåե졼basepriEXC_RETURNѤޤƤ
	 *  뤿ᡤå8byteˤʤäƤ롥
	 *  
	 */
	mov   r1, #0                   /* reqflgfalse */
	str   r1, [r0]

	/*
	 *  CPUå֤˰ܹԤ롥
	 *
	 *  ͥδγߤػߤ褦basepriꤷ
	 *  lock_flag  saved_iipm 򹹿롥saved_iipmϡγ
	 *  ͥ٥ޥʤɽˤꤹ롥
	 *  λCPUå֤ȤΤϡdispatcherʬȡ
	 *  call_texrtnƤӽФˡCPUå֤ˤʤäƤɬפ
	 *  Ǥ롥
     *  ʤνθ塤Thread⡼ɤؤΰܹԽԤʤᡤ
     *  å(FAULTMASK"1")ݻ롥
	 */
	ldr   r1, =IIPM_LOCK          /* CPUå */ 
	msr   basepri, r1          
	mov   r1, #0x01               /* lock_flag  true */
	ldr   r0, =lock_flag          
	str   r1, [r0]             
	mrs   r2, psp                 /* γͥ٥ޥ */
	ldr   r1, [r2,#4]             /* å         */
	ldr   r0, =saved_iipm         /* saved_iipm¸ */
	str   r1, [r0]             

	/*
	 *  Thread⡼ɤذܹԤ롥
	 *
	 *  dispatchercall_texrnƤӽФϡThread⡼ɤǤɬ
	 *  פ뤿ᡤPSPå˥ߡ㳰ե졼֤ơ
	 *  Ū˳ߥϥɥ餫꥿󤹤롥
	 *  ꥿ƱFAULTMASKưŪ˥ꥢ졤ͥ
	 *  ߤĤ롥
	 */
	ldr   r0, =ret_int_4          /* PC   */
	ldr   r1, =EPSR_T             /* xPSR(TӥåȤ'1'Ǥɬפ) */
	stmfd r2!, {r0-r1}            /* ߡե졼򥹥åѤ   */
	sub   r2, #(EXC_FRAME_SIZE - (4*2)) /* r0-r3,r12,lrƤꤹɬפʤ */
	msr   psp,r2                  
	bx    r3                      /* Thread⡼ɤذܹ */
    
ret_int_4:
	/*
	 *  嵭νˤꡤThread⡼ɤǼ¹Ԥ롥
	 *  dspflgfalseǤȡp_runtskp_schedtskƱˤϡ
	 *  ǥѥåԤʤΥåɬפʤΤϡ㳰
	 *  롼θƽФɬפʾˡǥѥåɬפʤƤ⡤
	 *  reqflgtrueˤ뤿Ǥ롥
	 */
	ldr   r0, =p_runtsk       /* ǥѥåԤʤǤ⡤r1p_runtsk (TCB) */
	ldr   r1, [r0]            /* äƤɬפΤǡɤ߹ */
	ldr   r0, =dspflg         
	ldr   r2, [r0]
	cbz   r2, ret_int_r_1     /* dspflgfalseʤret_int_r_1 */
	ldr   r0, =p_schedtsk     
	ldr   r2, [r0]
	cmp   r1, r2              /* p_runtskp_schedtskƱʤ */
	beq   ret_int_r_1         /*                  ret_int_r_1 */
	stmfd sp!, {r4-r11}       /* ĤΥ쥸¸ */
	str   sp, [r1,#TCB_sp]    /* å¸ */
	ldr   lr, =ret_int_r      /* ¹ԺƳϤ¸   */
	str   lr, [r1,#TCB_pc]
	b     dispatcher          /* ǥѥå */

/*
 * ߤˤץꥨץȤ줿ؤΥ꥿
 *
 * Thread⡼ɤǡǥѥåߤνиƤӽФ롥
 * ߤˤץꥨץȤ줿إ꥿󤹤ˤϡä
 * Handler⡼ɤ˰ܹԤPC0xfffffffdƥ꥿󤹤ɬ
 * 롥ΤᡤSVCˤꡤSVCϥɥƤӽФHandler⡼
 * ɤذܹԤ롥
 */
	.text
	.syntax unified
	.code 16
	.type ret_int_r, function
ret_int_r:
	pop {r4-r11}                  /* 쥸 */
ret_int_r_1:
	/*
	 *  enatextrueǡtexptn0ǤʤС㳰롼
	 *  ƤӽФ
	 *  dispatcherƤӽФ뤿ᡤTCBΥɥ쥹r1äƤ
	 */
	ldrb  r0, [r1,#TCB_enatex]
	tst   r0, #TCB_enatex_mask
	beq   ret_int_r_2           /* enatex  false ʤ ret_int_r_2 */
	ldr   r0, [r1,#TCB_texptn]  /* texptn                     */
	cbz   r0, ret_int_r_2       /* '0'ʤ꥿ */
	bl    call_texrtn           /* 㳰롼θƤӽФ */
ret_int_r_2:
	svc   0                     /* SVCθƤӽФ */

/*
 *  SVCϥɥ
 */
	.text
	.syntax unified
	.thumb
	.thumb_func
	.global svc_handler
	.type svc_handler, function
svc_handler:
	/*
	 *  ߽Υ꥿ˤꡤCPUå֤˰ܹԤ
	 *  롥
	 */
	cpsid f                       /* ߥå֤ */
	mrs   r0, psp
	add   r0, #EXC_FRAME_SIZE     /* åΤƤ   */
	msr   psp, r0
	mov   r0, #0
	ldr   r1, =lock_flag          /* CPUå֤ */
	str   r0, [r1]
	mrs   r0, psp                 /* ͥ٥ޥ򥿥å */
	ldmfd r0!, {r1,r2}            /* EXEC_RETURNɤ߼Τ */
	msr   psp, r0
	msr   basepri, r2             /* ͥ٥ޥ           */
	bx    lr                      /* إ꥿     */

/*
 *  ǥѥåư
 */
	.align	2
	.thumb
	.thumb_func
	.globl start_dispatch
start_dispatch:
	/*
	 *  Υ롼ϡͥ뵯ưˡ٤Ƥγߤػߤ
	 * ʳߥå֤ƱˤǸƤӽФ롥ޤߥ⡼ɡ
	 *  ƥȤƱˤǸƤӽФ뤳ȤꤷƤ롥
	 *
	 *  prc_initializeǡlock_flagtrueˡsaved_iipmIIPM_ENAALL
	 *  Ƥ뤿ᡤͥγߤĤ뤳Ȥǡ
	 *  CPUå֡ʥǥΡ˳ͥ٥ޥ֤ˤʤ롥
	 *  ޤtask_initializedisdspfalse˽Ƥ뤿ᡤǥ
	 *  ѥåľ֤ˤʤäƤ롥
	 */
	ldr   r0,=istkpt              /* MSP   */
	ldr   r1,[r0]                 /* start_dispatchƤӽФ˸ƤӽФѤ */
	msr   msp, r1                 /* ѤƤ뤿             */
	ldr   r1, =IIPM_LOCK          /* ͥγߤػ */
	msr   basepri, r1 
	cpsie f                       /* ͥγߤ */
	mov   r0, #CONTROL_PSP        /* PSPͭ  */
	msr   control, r0
	isb                           /* control ɬ */

/*
 *  ߤΥƥȤΤƤƥǥѥå
 */
	.align	2
	.thumb
	.thumb_func
    .globl exit_and_dispatch
exit_and_dispatch:
	/* ǥѥåΡdispatcherˤ */ 


/*
 *  ǥѥå
 */
dispatcher:
	/*
	 *  Υ롼ϡƥȡCPUå֡ǥѥå
	 *  ľ֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ
	 *  롥
	 *
	 *  ʤThread⡼ɡlock_flagtruedisdspfalsedspflg
	 *  truesaved_iipmIIPM_ENAALLȤʤäƤ롥¹ԺƳϤؤ⤳
	 *  ξ֤Τޤʬ롥
	 */
#ifdef LOG_DSP_ENTER
	ldr   r1, =p_runtsk     /* p_runtskѥ᡼ */
	ldr   r0, [r1]        
	bl    log_dsp_enter
#endif /* LOG_DSP_ENTER */
dispatcher_0:
	ldr   r0, =p_schedtsk   /* p_schedtskp_runtsk */
	ldr   r1, [r0]
	ldr   r2, =p_runtsk   
	str   r1, [r2]        
	cmp   r1, #0            /* p_runtskNULLʤdispatcher_1 */
	beq   dispatcher_1             
	ldr   sp, [r1,#TCB_sp]  /* å */
#ifdef LOG_DSP_LEAVE
	mov   r0, r1            /* p_runtskѥ᡼ */
	mov   r4, r1            /* r1ϥå쥸ʤΤ¸ */
	bl    log_dsp_leave
	mov   r1, r4
#endif /* LOG_DSP_LEAVE */
	ldr   pc, [r1,#TCB_pc]  /* ¹ԺƳϤ   */    
dispatcher_1:
	/*
	 * CPUå֤βȡ󥿥ƥȼ¹Ծ֤ؤ
	 * 򤹤
	 */
	mov   r0, #CONTROL_MSP  /* MSPͭ  */
	msr   control, r0       
	isb                     /* control ɬ */
	ldr   r2, =reqflg       /* r2 <- reqflg */
	ldr   r1, =IIPM_LOCK    /* ߥå֤γͥ٥ޥ */
	mov   r0, #0
	ldr   r4, =lock_flag    /* CPUå֤ */
	str   r0, [r4]
dispatcher_2:
	/*
	 *  ߤĤ󥿥ƥȼ¹Ծ֤ȤߤԤġ
	 *
	 *  󥿥ƥȼ¹Ծ֤ڤ괹Τϡȯ
	 *  ߽ˤɤΥåȤȤβȡ
	 *  ϥɥǤΥǥѥåɻߤȤ2Ĥΰ̣롥
	 *
	 *  ץåԤ˰ܹԤȡߵĤȤϡԲ
	 *  ʬ˹Ԥʤɬפ롥
	 *  Բʬ˹Ԥʤʤ硤ߤĤľ˳
	 *  ߤꡤǥ¹Բǽ֤ˤʤȡ¹Ԥ٤
	 *  ˤ⤫餺ץåԤˤʤäƤޤ
	 *  ARM-MǤϡPRIMASK򥻥åȤ֤WFIƤӽФȤǼ¸Ǥ롥
	 *  ξ֤ǳߤȡߤϼ¹Ԥ줺WFI꥿
	 *  뤳ȤˤʤΤǡöߤĤƳߥϥɥ¹Ԥ롥
	 *
	 *  Ԥδ֤ϡp_runtskNULLʡ0ˤꤷʤФʤ
	 *  Τ褦ꤷʤȡߥϥɥ餫iget_tidƤӽ
	 *  ݤưͤ˹פʤʤ롥
	 *
	 */
#ifdef TOPPERS_CUSTOM_IDLE
	toppers_asm_custom_idle
#else
	cpsid i               /* PRIMASK 򥻥å */
	msr   basepri, r0     /* ߵ */ 
	wfi
	cpsie i               /* PRIMASK 򥯥ꥢʳߤդ */
	msr   basepri, r1     /* CPUå֤ */ 
#endif /* TOPPERS_CUSTOM_IDLE */

	ldr   r6, [r2]        /* reqflgfalseʤdispatcher_2 */
	cmp   r6, #0
	beq   dispatcher_2
	str   r0, [r2]        /* reqflgfalse */

	/*
	 *  CPUå֤᤹Ԥδ֤˼¹Ԥߥϥɥˤ
	 *  ꡤsaved_iipm񤭴ǽ뤿ᡤ᤹ͤɬ
	 *  פ롥dispatcher¹Ԥϡsaved_iipmIIPM_ENAALL
	 *  ȤʤäƤ뤿ᡤǤsaved_iipmIIPM_ENAALLʡ0ˤ᤻
	 *  Ф褤
	 */
	mov   r0, #CONTROL_PSP  /* PSPͭ  */ 
	msr   control, r0      
	isb                     /* control ɬ */
	mov   r2, #1            /* lock_flagtrue */
	ldr   r4, =lock_flag  
	str   r2, [r4]
	ldr   r4, =saved_iipm   /* saved_iipm 0 */
	mov   r0, #0
	str   r0, [r4]
	b     dispatcher_0


/*
 *  ͥνλθƽФ
 *
 *  å󥿥ƥѤڤؤ
 *  
 */
	.text
	.syntax unified
	.code 16
	.globl call_exit_kernel
	.type call_exit_kernel, function
call_exit_kernel:
	mov   r0, #CONTROL_MSP
	msr   control, r0       /* MSPͭ  */
	isb                     /* control ɬ */
	b     exit_kernel       /* ͥνλƤ */


/*
 *  ư
 *
 *  dispatcherƤӽФ뤿ᡤTCBΥɥ쥹r1äƤ
 *
 */ 
	.text
	.syntax unified
	.code 16
	.global start_r
	.type start_r, function
start_r:
	mov   r0, #0
	ldr   r4, =lock_flag                    /* CPUå֤ */
	str   r0, [r4]
	msr   basepri, r0                       /* ߵ   */
	ldr   lr, =ext_tsk                      /*  */
	ldr   r2, [r1, #TCB_p_tinib]            /* p_runtsk->p_tinibr2  */
	ldr   r0, [r2, #TINIB_exinf]            /* exinf쥸r0  */
	ldr   r1, [r2, #TINIB_task]             /* ưϤ˥ */
	mov   pc, r1 

/*
 *  Ԥ
 */
	.text
	.syntax unified
	.code 16
	.globl sil_dly_nse
	.type sil_dly_nse, function
sil_dly_nse:
	sub   r0, r0, #SIL_DLY_TIM1
	cmp   r0, #0
	bgt   sil_dly_nse1
	mov   pc, lr
sil_dly_nse1:
	sub   r0, r0, #SIL_DLY_TIM2
	cmp   r0, #0
	bgt   sil_dly_nse1
	mov   pc, lr
